import { world, system, TicksPerSecond } from '@minecraft/server';

// Function to apply the bleeding effect
function applyBleedingEffect(victim) {
    const bleedDuration = 5 * TicksPerSecond; // Total duration of the bleeding effect (5 seconds)
    const bleedDamage = 1; // Damage inflicted per interval
    const damageInterval = 1 * TicksPerSecond; // Interval between each damage application (1 second)

    let elapsedTicks = 0;

    // Function to apply damage at each interval
    function bleedTick() {
        // Check if the bleeding duration has been reached or if the victim is no longer valid
        if (elapsedTicks >= bleedDuration || !victim || !victim.isValid()) {
            return; // Stop the bleeding effect
        }

        // Apply damage to the victim
        victim.applyDamage(bleedDamage, {
            cause: 'magic', // Cause of the damage
        });

        elapsedTicks += damageInterval;
        system.runTimeout(bleedTick, damageInterval); // Schedule the next damage application
    }

    // Start the bleeding effect
    system.runTimeout(bleedTick, damageInterval);
}

// Event listener for when an entity is hurt
world.afterEvents.entityHurt.subscribe((event) => {
    const { damagingEntity, hurtEntity } = event;

    // Ensure both the damager and the victim are valid entities
    if (!damagingEntity || !hurtEntity) return;

    // Check if the damager is a player
    if (damagingEntity.typeId === 'minecraft:player') {
        const inventory = damagingEntity.getComponent('minecraft:inventory');
        const itemInHand = inventory?.container?.getItem(damagingEntity.selectedSlot);

        // Check if the item in hand is a sword
        if (itemInHand && itemInHand.typeId.includes('sword')) {
            // Apply the bleeding effect with a 30% chance
            if (Math.random() < 0.3) {
                applyBleedingEffect(hurtEntity);
            }
        }
    }
}); and give XP
    block.dimension.spawnItem(itemStack, block.location);
    block.dimension.runCommand(`xp ${totalDrop}L ${player.name}`);
});